# -*- coding: utf-8 -*-
import xbmc, xbmcgui, xbmcplugin
import sys, json
try:
    from urllib2 import urlopen
except ImportError:
    from urllib.request import urlopen
try:
    from urllib import urlencode
except ImportError:
    from urllib.parse import urlencode
try:
    from urlparse import urlparse, parse_qs
except ImportError:
    from urllib.parse import urlparse, parse_qs
import cntv


def resp(ret, recur=False):
    if 'code' in ret:
        if 'error' in ret:
            return xbmcgui.Dialog().ok('Error: ' + ret['code'], ret['error'])
        return xbmcgui.Dialog().ok('Error', ret['code'])
    if isinstance(ret, list):
        xbmcplugin.setContent(handle, 'videos')
        for elem in ret:
            resp(elem, True)
        return xbmcplugin.endOfDirectory(handle)
    assert isinstance(ret, dict)
    if 'title' not in ret:
        for k, v in ret.items():
            if isinstance(v, list):
                ret = {'title': k, 'json': json.dumps(v)}
            else:
                ret = {'title': k, 'url': v}
    li = xbmcgui.ListItem(ret['title'])
    if 'img' in ret:
        li.setArt({'thumb': ret['img']})
    if 'plot' in ret:
        li.setInfo('video', {'plot': ret['plot']})
    t = True
    if 'url' in ret:
        if isinstance(ret['url'], list):
            ret['url'] = 'stack://' + ' , '.join(ret['url'])
            if 'header' in ret:
                ret['url'] += '|' + urlencode(ret['header'])
            if recur:
                return xbmcplugin.addDirectoryItem(handle, ret['url'], li)
            else:
                return xbmc.Player().play(ret['url'], li)
        o = urlparse(ret['url'])
        p = o.path.split('/')
        ext = p[-1].split('.')[-1]
        if ext in ('m3u', 'm3u8'):
            if 'header' in ret:
                ret['url'] += '|' + urlencode(ret['header'])
            if recur:
                return xbmcplugin.addDirectoryItem(handle, ret['url'], li)
            else:
                return xbmc.Player().play(ret['url'], li)
        if t:
            t = sub1(ret['url'])
    for k, v in ret.items():
        try:
            ret[k] = v.encode('utf-8')
        except:
            pass
    xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode(ret), li, t)


def sub1(url):
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    if o.netloc.endswith('.cctv.com') and p[-1].startswith('VIDE') and p[-1].endswith('.shtml'):
        return False
    if o.netloc.endswith('.cntv.cn') and p[1] == 'video':
        return False
    # if o.netloc == 'vdn.live.cntv.cn':
    #	return False
    return True


def sub2(url):
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    # http://tv.cctv.com/2017/08/01/VIDATpMb8AuFgveEQWuoBhJN170801.shtml
    # http://kejiao.cntv.cn/2012/12/15/VIDA1355519857003716.shtml
    if p[-1].startswith('VIDA') and p[-1].endswith('.shtml'):
        return resp(cntv.vida(url))
    if o.netloc.endswith('.cctv.com'):
        # http://tv.cctv.com/lm/tsfx/videoset/index.shtml
        if p[1] == 'lm':
            return resp(cntv.lm(url))
        # http://tv.cctv.com/2020/01/02/VIDEKBknjsr1ruhYhUNaFqKl200102.shtml
        if p[-1].startswith('VIDE') and p[-1].endswith('.shtml'):
            return resp(cntv.play(url))
    if o.netloc.endswith('.cntv.cn'):
        # http://tv.cntv.cn/videoset/VSET100169831220
        # http://tv.cntv.cn/videoset/C14092
        if p[1] == 'videoset':
            return resp(cntv.vset(url))
        # http://tv.cntv.cn/video/VSET100169831220/989a30af701e4de0b90eadde452adc51
        # http://tv.cntv.cn/video/C14092/bf544ab8f9744ef5ac3d55fc75ba4dc3
        if p[1] == 'video':
            return resp(cntv.play(url))
    # http://api.cntv.cn/lanmu/videolistByColumnId?id=TOPC1451557893544236&serviceId=tvcctv&type=0&n=36&p=1&t=json
    if o.netloc == 'api.cntv.cn':
        return resp(cntv.videolist(url))
    # elif o.netloc == 'vdn.live.cntv.cn':
    #	ret = cntv.live(url)
    return resp({'code': 'cntv 020', 'error': url})


def sub3(content):
    try:
        data = json.loads(content)
    except Exception as e:
        return resp({'code': 'cntv 030', 'error': str(e)})
    resp(data)


def get_node(url):
    try:
        content = urlopen(url).read().decode('utf-8')
    except Exception as e:
        return resp({'code': 'cntv 010', 'error': str(e)})
    sub3(content)


handle = int(sys.argv[1])
url = sys.argv[2]
if not url:
    get_node('http://ims.tian-le.com/cntv.json')
else:
    o = urlparse(url)
    q = parse_qs(o.query, True)
    if 'json' in q:
        sub3(q['json'][0])
    elif 'url' in q:
        sub2(q['url'][0])
